﻿using System;

namespace QuantRiskLib
{
    public partial class Distributions
    {
        /// <summary>
        /// For n independent draws from a standard uniform distribution (range = 0-1), the probability that the minimum is less than or equal to x.
        /// </summary>
        public static double IndependentStandardUniformMinimumCumulativeDistributionFunction(double x, int nDistributions)
        {
            double p = 0;
            int sign = 1;
            for (int i = 1; i < nDistributions; i++)
            {
                p += MMath.Combinations(nDistributions, i) * Math.Pow(x, i) * sign;
                sign *= -1;
            }
            return p;
        }

        /// <summary>
        /// For n independent draws from a standard uniform distribution (range = 0-1), the probability that the maximum is less than or equal to x.
        /// </summary>
        public static double IndependentStandardUniformMaximumCumulativeDistributionFunction(double x, int nDistributions)
        {
            return Math.Pow(x, nDistributions);
        }
    }
}
